"use strict";
var react_dom_1 = require("react-dom");
var react_router_1 = require("react-router");
var react_router_redux_1 = require("react-router-redux");
var redux_immutable_1 = require("redux-immutable");
var Immutable = require("immutable");
var root_1 = require("./containers/root");
var configure_store_1 = require("./store/configure_store");
var initialRouterReducerState = Immutable.fromJS({
    locationBeforeTransitions: null
});
var routerReducer = function (state, action) {
    if (state === void 0) { state = initialRouterReducerState; }
    if (action.type === react_router_redux_1.LOCATION_CHANGE) {
        return state.merge({
            locationBeforeTransitions: action.payload
        });
    }
    return state;
};
function bootstrap(options) {
    if (options === undefined) {
        throw new TypeError("Null argument options.");
    }
    ;
    if (options.routes === undefined) {
        throw new TypeError("Invalid configuration field: routes.");
    }
    ;
    if (options.reducers === undefined) {
        throw new TypeError("Invalid configuration field: reducers.");
    }
    ;
    var routes = options.routes;
    var reducers = options.reducers;
    var container = options.container || "root";
    var initialState = options.initialState || {};
    var immutableInitialState = Immutable.fromJS(initialState);
    var middlewares = options.middlewares || [];
    reducers.routing = routerReducer;
    var rootReducer = redux_immutable_1.combineReducers(reducers);
    var routerMddlwr = react_router_redux_1.routerMiddleware(react_router_1.browserHistory);
    var store = configure_store_1.default(middlewares.concat([routerMddlwr]), rootReducer, immutableInitialState);
    var history = react_router_redux_1.syncHistoryWithStore(react_router_1.browserHistory, store, {
        selectLocationState: function (state) { return state.get("routing").toJS(); }
    });
    react_dom_1.render(root_1.default(store, history, routes), document.getElementById(container));
    return store;
}
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = bootstrap;
